/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.base.objects.factory.tracker;

import java.util.List;

import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;
import org.osgi.service.component.ComponentContext;
import org.osgi.service.component.annotations.Activate;
import org.osgi.service.component.annotations.Component;
import org.osgi.service.component.annotations.Deactivate;
import org.osgi.service.component.annotations.Reference;
import org.osgi.service.component.annotations.ReferenceCardinality;
import org.osgi.util.tracker.BundleTracker;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ru.entaxy.platform.base.support.osgi.tracker.BundleTrackerUtils;
import ru.entaxy.platform.base.support.osgi.tracker.filter.BundleHeaderFilter;

@Component(service = {TrackerManager.class}, immediate = true)
public class TrackerManager {

	private static final Logger log = LoggerFactory.getLogger(TrackerManager.class);
	
	public static final String HEADER_ENTAXY_FACTORY_PROVIDER = "Entaxy-Factory-Provider";
	public static final String HEADER_ENTAXY_DYNAMIC_FACTORY_PROVIDER = "Entaxy-Dynamic-Factory-Provider";
	public static final String HEADER_ENTAXY_DYNAMIC_FACTORY_URL = "Entaxy-Dynamic-Factory-Url";

	protected BundleContext bundleContext;
	
	protected BundleTracker<TrackedFactoryContainer> factoryTracker;

	protected BundleTracker<TrackedFactoryContainer> dynamicFactoryTracker;
	
	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	TrackedFactoryManager factoryManager;
	
	@Activate
	public void activate(ComponentContext componentContext) {
		this.bundleContext = componentContext.getBundleContext();
		log.debug("Activated: " + bundleContext.getBundle().getBundleId());
		
		factoryTracker = BundleTrackerUtils.<TrackedFactoryContainer>createBuilder()
				.addFilter(
					(new BundleHeaderFilter()).header(HEADER_ENTAXY_FACTORY_PROVIDER)	
				)
				.customizer(
					(new TrackedFactoryCustomizer())
					// .listener(new TrackedFactoryCustomizerListener(bundleContext))
					.listener(factoryManager)
				)
				.bundleState(Bundle.ACTIVE | Bundle.INSTALLED | Bundle.RESOLVED | Bundle.STARTING | Bundle.STOPPING)
				.get();
		factoryTracker.open();
		dynamicFactoryTracker = BundleTrackerUtils.<TrackedFactoryContainer>createBuilder()
				.addFilter(
					(new BundleHeaderFilter()).header(HEADER_ENTAXY_DYNAMIC_FACTORY_PROVIDER)	
				)
				.customizer(
					(new TrackedDynamicFactoryCustomizer())
					// .listener(new TrackedFactoryCustomizerListener(bundleContext))
					.listener(factoryManager)
				)
				.bundleState(Bundle.ACTIVE | Bundle.INSTALLED | Bundle.RESOLVED)
				.get();
		dynamicFactoryTracker.open();
		log.debug("Factory tracker started");
	}
	
	@Deactivate
	public void deactivate(ComponentContext componentContext) {
		factoryTracker.close();
	}
}
